//********************************************************************
//*** ResourcePool/mysql/SQLExecute.hh
//*** Copyright (c) 2003-2008 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLExecute.hh,v 1.18 2008/01/27 16:42:28 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_MYSQL_RESOURCEPOOL_HH
#include "ResourcePool.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_SQLEXECUTE_HH
#define RESOURCEPOOL_MYSQL_SQLEXECUTE_HH

#ifndef RESOURCEPOOL_COMMAND_HH
#include "ResourcePool/Command.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_SQLTYPE_HH
#include "SQLType.hh"
#endif

#ifndef RESOURCEPOOL_MYSQL_MYSQLFWD_HH
#include "mysqlFwd.hh"
#endif

#ifndef INCLUDED_GC_PTR_HH
#include "mm/gc_ptr.hh"
#endif

#ifndef RESOURCEPOOL_SQL_BIND_HH
#include "ResourcePool/SQL/Bind.hh"
#endif

#include <string>

namespace fatalmind {
namespace mysql {

/**
 * A Command to issue an non-select statement (update, insert, delete)
 * against a mysql database.
 */
class SQLExecute
: public Command<fatalmind::ResourceType::mysql>
, public SQL::Bind<SQLType, SQLTypeImpl> 
{
	public:
		SQLExecute(const std::string& SQL);
		SQLExecute(const ResourcePool<ResourceType>& p, const std::string& SQL);
		virtual ~SQLExecute();
		virtual void execute(mysqlResource&);

	protected:
		virtual Clone* DoClone() const;

	private:
		std::string _SQL;
};


} // namespace mysql
} // namespace fatalmind
#endif
